<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Generated by Apache Maven Doxia Site Renderer 1.3 at Oct 27, 2017 -->
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=${outputEncoding}" />
    <title>CPD Results</title>
    <style type="text/css" media="all">
      @import url("./css/maven-base.css");
      @import url("./css/maven-theme.css");
      @import url("./css/site.css");
    </style>
    <link rel="stylesheet" href="./css/print.css" type="text/css" media="print" />
    <meta name="Date-Revision-yyyymmdd" content="20171027" />
    <meta http-equiv="Content-Language" content="en" />
        
        </head>
  <body class="composite">
    <div id="banner">
                      <div class="clear">
        <hr/>
      </div>
    </div>
    <div id="breadcrumbs">
            
            
                <div class="xleft">
        <span id="publishDate">Last Published: 2017-10-27</span>
                  &nbsp;| <span id="projectVersion">Version: ${project.version}</span>
                      </div>
            <div class="xright">        
            
      </div>
      <div class="clear">
        <hr/>
      </div>
    </div>
    <div id="leftColumn">
      <div id="navcolumn">
             
            
                                      <a href="http://maven.apache.org/" title="Built by Maven" class="poweredBy">
        <img class="poweredBy" alt="Built by Maven" src="./images/logos/maven-feather.png" />
      </a>
                   
            
            </div>
    </div>
    <div id="bodyColumn">
      <div id="contentBox">
        <div class="section"><h2>CPD Results<a name="CPD_Results"></a></h2><p>The following document contains the results of PMD's  <a class="externalLink" href="http://pmd.sourceforge.net/cpd.html">CPD</a> 5.0.5.</p></div><div class="section"><h2>Duplications<a name="Duplications"></a></h2><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.java</td><td><a href="./xref/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.html#L355">355</a></td></tr><tr class="a"><td>org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppInnerClassifiers.java</td><td><a href="./xref/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppInnerClassifiers.html#L55">55</a></td></tr><tr class="b"><td colspan='2'><div><pre>    _builder.append(_CppClassTypeAndEnum, &quot;    &quot;);
    _builder.newLineIfNotEmpty();
    _builder.append(&quot;\t&quot;);
    VisibilityKind publicVisibility = VisibilityKind.PUBLIC_LITERAL;
    _builder.newLineIfNotEmpty();
    _builder.append(&quot;\t&quot;);
    String _defaultInitializer = CppClassifierGenerator.defaultInitializer(classifier);
    String _section = CppGenUtils.getSection(publicVisibility, _defaultInitializer);
    _builder.append(_section, &quot;\t&quot;);
    _builder.newLineIfNotEmpty();
    _builder.append(&quot;\t&quot;);
    CharSequence _CppClassAttributesDeclaration = CppClassAttributesDeclaration.CppClassAttributesDeclaration(classifier, publicVisibility);
    String _string = _CppClassAttributesDeclaration.toString();
    String _section_1 = CppGenUtils.getSection(publicVisibility, _string);
    _builder.append(_section_1, &quot;\t&quot;);
    _builder.newLineIfNotEmpty();
    _builder.append(&quot;\t&quot;);
    CharSequence _CppClassOperationsDeclaration = CppClassOperationsDeclaration.CppClassOperationsDeclaration(classifier, publicVisibility);
    String _string_1 = _CppClassOperationsDeclaration.toString();
    String _section_2 = CppGenUtils.getSection(publicVisibility, _string_1);
    _builder.append(_section_2, &quot;\t&quot;);
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append(&quot;\t&quot;);
    VisibilityKind protectedVisibility = VisibilityKind.PROTECTED_LITERAL;
    _builder.newLineIfNotEmpty();
    _builder.append(&quot;\t&quot;);
    CharSequence _CppClassAttributesDeclaration_1 = CppClassAttributesDeclaration.CppClassAttributesDeclaration(classifier, protectedVisibility);
    String _string_2 = _CppClassAttributesDeclaration_1.toString();
    String _section_3 = CppGenUtils.getSection(protectedVisibility, _string_2);
    _builder.append(_section_3, &quot;\t&quot;);
    _builder.newLineIfNotEmpty();
    _builder.append(&quot;\t&quot;);
    CharSequence _CppClassOperationsDeclaration_1 = CppClassOperationsDeclaration.CppClassOperationsDeclaration(classifier, protectedVisibility);
    String _string_3 = _CppClassOperationsDeclaration_1.toString();
    String _section_4 = CppGenUtils.getSection(protectedVisibility, _string_3);
    _builder.append(_section_4, &quot;\t&quot;);
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append(&quot;\t&quot;);
    VisibilityKind privateVisibility = VisibilityKind.PRIVATE_LITERAL;
    _builder.newLineIfNotEmpty();
    _builder.append(&quot;\t&quot;);
    CharSequence _CppClassAttributesDeclaration_2 = CppClassAttributesDeclaration.CppClassAttributesDeclaration(classifier, privateVisibility);
    String _string_4 = _CppClassAttributesDeclaration_2.toString();
    String _section_5 = CppGenUtils.getSection(privateVisibility, _string_4);
    _builder.append(_section_5, &quot;\t&quot;);
    _builder.newLineIfNotEmpty();
    _builder.append(&quot;\t&quot;);
    CharSequence _CppClassOperationsDeclaration_2 = CppClassOperationsDeclaration.CppClassOperationsDeclaration(classifier, privateVisibility);
    String _string_5 = _CppClassOperationsDeclaration_2.toString();
    String _section_6 = CppGenUtils.getSection(privateVisibility, _string_5);
    _builder.append(_section_6, &quot;\t&quot;);
    _builder.newLineIfNotEmpty();
    _builder.append(&quot;};&quot;);
    _builder.newLine();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.java</td><td><a href="./xref/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.html#L212">212</a></td></tr><tr class="a"><td>org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.java</td><td><a href="./xref/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.html#L594">594</a></td></tr><tr class="b"><td colspan='2'><div><pre>    _builder.newLine();
    _builder.newLine();
    _builder.append(&quot;// Derived includes directives&quot;);
    _builder.newLine();
    {
      Iterable&lt;String&gt; _CppClassAllIncludesDeclarationBody = CppClassIncludeClassDeclaration.CppClassAllIncludesDeclarationBody(classifier);
      List&lt;String&gt; _sort = IterableExtensions.&lt;String&gt;sort(_CppClassAllIncludesDeclarationBody);
      for(final String path : _sort) {
        String _includeDirective_1 = CppIncludeUtil.includeDirective(path);
        _builder.append(_includeDirective_1, &quot;&quot;);
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.newLine();
    String _CppIncludeBody = CppIncludeUtil.CppIncludeBody(classifier);
    _builder.append(_CppIncludeBody, &quot;&quot;);
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    String _openNS = CppGenUtils.openNS(classifier);
    _builder.append(_openNS, &quot;&quot;);
    _builder.newLineIfNotEmpty();
    _builder.newLine();</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppParameter.java</td><td><a href="./xref/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppParameter.html#L37">37</a></td></tr><tr class="a"><td>org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppParameter.java</td><td><a href="./xref/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppParameter.html#L66">66</a></td></tr><tr class="b"><td colspan='2'><div><pre>      EList&lt;Parameter&gt; _ownedParameters = operation.getOwnedParameters();
      final Function1&lt;Parameter, Boolean&gt; _function = new Function1&lt;Parameter, Boolean&gt;() {
        @Override
        public Boolean apply(final Parameter it) {
          ParameterDirectionKind _direction = it.getDirection();
          return Boolean.valueOf((!Objects.equal(_direction, ParameterDirectionKind.RETURN_LITERAL)));
        }
      };
      Iterable&lt;Parameter&gt; _filter = IterableExtensions.&lt;Parameter&gt;filter(_ownedParameters, _function);
      boolean _hasElements = false;
      for(final Parameter ownedParameter : _filter) {
        if (!_hasElements) {
          _hasElements = true;
        } else {
          _builder.appendImmediate(&quot;, &quot;, &quot;&quot;);
        }
        String _CppParameter = CppParameter.CppParameter(ownedParameter, showDefault);
        _builder.append(_CppParameter, &quot;&quot;);
      }
    }</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassOperationsImplementation.java</td><td><a href="./xref/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassOperationsImplementation.html#L39">39</a></td></tr><tr class="a"><td>org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassOperationsImplementation.java</td><td><a href="./xref/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassOperationsImplementation.html#L78">78</a></td></tr><tr class="b"><td colspan='2'><div><pre>      final Function1&lt;Operation, Boolean&gt; _function = new Function1&lt;Operation, Boolean&gt;() {
        @Override
        public Boolean apply(final Operation it) {
          boolean _and = false;
          boolean _or = false;
          boolean _hasStereotype = GenUtils.hasStereotype(it, NoCodeGen.class);
          if (_hasStereotype) {
            _or = true;
          } else {
            boolean _isAbstract = it.isAbstract();
            _or = _isAbstract;
          }
          boolean _not = (!_or);
          if (!_not) {
            _and = false;
          } else {
            boolean _hasStereotype_1 = GenUtils.hasStereotype(it, Inline.class);
            boolean _equals = (_hasStereotype_1 == inline);
            _and = _equals;
          }
          return Boolean.valueOf(_and);
        }
      };
      Iterable&lt;Operation&gt; _filter = IterableExtensions.&lt;Operation&gt;filter(_ownedOperations, _function);</pre></div></td></tr></table><table align="center" border="0" class="bodyTable"><tr class="a"><th>File</th><th>Line</th></tr><tr class="b"><td>org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.java</td><td><a href="./xref/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.html#L53">53</a></td></tr><tr class="a"><td>org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.java</td><td><a href="./xref/org/eclipse/papyrus/designer/languages/cpp/codegen/xtend/CppClassifierGenerator.html#L280">280</a></td></tr><tr class="b"><td colspan='2'><div><pre>  public static CharSequence generateBindHeaderCode(final Classifier classifier) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append(&quot;#ifndef &quot;);
    String _fullNameUC = GenUtils.getFullNameUC(classifier);
    _builder.append(_fullNameUC, &quot;&quot;);
    _builder.append(&quot;_H&quot;);
    _builder.newLineIfNotEmpty();
    _builder.append(&quot;#define &quot;);
    String _fullNameUC_1 = GenUtils.getFullNameUC(classifier);
    _builder.append(_fullNameUC_1, &quot;&quot;);
    _builder.append(&quot;_H&quot;);
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append(&quot;/************************************************************&quot;);
    _builder.newLine();
    _builder.append(&quot;              &quot;);
    String _name = classifier.getName();
    _builder.append(_name, &quot;              &quot;);
    _builder.append(&quot; template binding header&quot;);</pre></div></td></tr></table></div>
      </div>
    </div>
    <div class="clear">
      <hr/>
    </div>
    <div id="footer">
      <div class="xright">
              Copyright &#169;  All Rights Reserved.      
            
                  </div>
      <div class="clear">
        <hr/>
      </div>
    </div>
  </body>
</html>
